#include "lfn.h"
#include <stdio.h>
#include <string.h>

WORD __lfnerrno = 0;	
BYTE __lfnwarnings = 1;
/* 0	prints all */
/* 1	prints errors only */
/* 2	prints all but selected errors */ 

/* Values for DOS extended error code: */
void	error_code(const char *name, WORD code)	
{
	__lfnerrno = code;		

	if (code == 0x7100) {
		printf("%s not supported\n", name);
		return;
	 }

	if (__lfnwarnings > 1) {
		if ( (strcmp(name,"find next file") ==0) && code == 0x12 ) 
		return;
	}					

	if (code == 0 ) {
		if ( __lfnwarnings == 0) {
			printf("%s passed\n", name);	
		}
		return;
	} else {
		printf("%s error:", name);	
	}

	if ( strcmp(name,"truename") ==0 ) {
		switch (code)
		{
 	 		case 0x1 : 
				puts(" function number invalid"); 
				break;
			case 0x2 : 
				puts(" invalid component in directory path or drive letter only"); 
				break;
			case 0x3 : 
				puts(" malformed path or invalid drive letter"); 
				break;
			default  : 
				printf(" unknown error code: %u\n", code); 
				break;
		}
		return;
	}
	if ( strcmp(name,"reset drive") ==0 && (code == 1)) {
		puts(" operation failed");
		return;
	}
	switch (code)
	{
 	 	case 0x00 : puts(" no error"); break;
 	 	case 0x01 : puts(" function number invalid"); break;
 	 	case 0x02 : puts(" file not found"); break;
 	 	case 0x03 : puts(" path not found"); break;
 	 	case 0x04 : puts(" too many open files (no handles available)"); break;
 	 	case 0x05 : puts(" access denied"); break;
 	 	case 0x06 : puts(" invalid handle"); break;
 	 	case 0x07 : puts(" memory control block destroyed"); break;
 	 	case 0x08 : puts(" insufficient memory"); break;
 	 	case 0x09 : puts(" memory block address invalid"); break;
 	 	case 0x0A : puts(" environment invalid (usually >32K in length)"); break;
 	 	case 0x0B : puts(" format invalid"); break;
 	 	case 0x0C : puts(" access code invalid"); break;
 	 	case 0x0D : puts(" data invalid"); break;
 	 	case 0x0E : puts(" reserved"); break;
 	 	case 0x0F : puts(" invalid drive"); break;
 	 	case 0x10 : puts(" attempted to remove current directory"); break;
 	 	case 0x11 : puts(" not same device"); break;
 	 	case 0x12 : puts(" no more files"); break;
 	 	case 0x13 : puts(" disk write-protected"); break;
 	 	case 0x14 : puts(" unknown unit"); break;
 	 	case 0x15 : puts(" drive not ready"); break;
 	 	case 0x16 : puts(" unknown command"); break;
 	 	case 0x17 : puts(" data error (CRC)"); break;
 	 	case 0x18 : puts(" bad request structure length"); break;
 	 	case 0x19 : puts(" seek error"); break;
 	 	case 0x1A : puts(" unknown media type (non-DOS disk)"); break;
 	 	case 0x1B : puts(" sector not found"); break;
 	 	case 0x1C : puts(" printer out of paper"); break;
 	 	case 0x1D : puts(" write fault"); break;
 	 	case 0x1E : puts(" read fault"); break;
 	 	case 0x1F : puts(" general failure"); break;
 	 	case 0x20 : puts(" sharing violation"); break;
 	 	case 0x21 : puts(" lock violation"); break;
 	 	case 0x22 : puts(" disk change invalid (ES:DI -> media ID structure)(see #01681)"); break;
 	 	case 0x23 : puts(" FCB unavailable"); break;
 	 	case 0x24 : puts(" sharing buffer overflow"); break;
 	 	case 0x25 : puts(" (DOS 4.0+) code page mismatch"); break;
 	 	case 0x26 : puts(" (DOS 4.0+) cannot complete file operation (out of input)"); break;
 	 	case 0x27 : puts(" (DOS 4.0+) insufficient disk space"); break;
 	 	case 0x28 : puts(" reserved"); break;
 	 	case 0x29 : puts(" reserved"); break;
 	 	case 0x2A : puts(" reserved"); break;
 	 	case 0x2B : puts(" reserved"); break;
 	 	case 0x2C : puts(" reserved"); break;
 	 	case 0x2D : puts(" reserved"); break;
 	 	case 0x2E : puts(" reserved"); break;
 	 	case 0x2F : puts(" reserved"); break;
 	 	case 0x30 : puts(" reserved"); break;
 	 	case 0x31 : puts(" reserved"); break;
 	 	case 0x32 : puts(" network request not supported"); break;
 	 	case 0x33 : puts(" remote computer not listening"); break;
 	 	case 0x34 : puts(" duplicate name on network"); break;
 	 	case 0x35 : puts(" network name not found"); break;
 	 	case 0x36 : puts(" network busy"); break;
 	 	case 0x37 : puts(" network device no longer exists"); break;
 	 	case 0x38 : puts(" network BIOS command limit exceeded"); break;
 	 	case 0x39 : puts(" network adapter hardware error"); break;
 	 	case 0x3A : puts(" incorrect response from network"); break;
 	 	case 0x3B : puts(" unexpected network error"); break;
 	 	case 0x3C : puts(" incompatible remote adapter"); break;
 	 	case 0x3D : puts(" print queue full"); break;
 	 	case 0x3E : puts(" queue not full"); break;
 	 	case 0x3F : puts(" not enough space to print file"); break;
 	 	case 0x40 : puts(" network name was deleted"); break;
 	 	case 0x41 : puts(" network: Access denied"); break;
 	 	case 0x42 : puts(" network device type incorrect"); break;
 	 	case 0x43 : puts(" network name not found"); break;
 	 	case 0x44 : puts(" network name limit exceeded"); break;
 	 	case 0x45 : puts(" network BIOS session limit exceeded"); break;
 	 	case 0x46 : puts(" temporarily paused"); break;
 	 	case 0x47 : puts(" network request not accepted"); break;
 	 	case 0x48 : puts(" network print/disk redirection paused"); break;
 	 	case 0x49 : puts(" network software not installed; (LANtastic) invalid network version"); break;
 	 	case 0x4A : puts(" unexpected adapter close; (LANtastic) account expired"); break;
 	 	case 0x4B : puts(" (LANtastic) password expired"); break;
 	 	case 0x4C : puts(" (LANtastic) login attempt invalid at this time"); break;
 	 	case 0x4D : puts(" (LANtastic v3+) disk limit exceeded on network node"); break;
 	 	case 0x4E : puts(" (LANtastic v3+) not logged in to network node"); break;
 	 	case 0x4F : puts(" reserved"); break;
 	 	case 0x50 : puts(" file exists"); break;
 	 	case 0x51 : puts(" reserved"); break;
 	 	case 0x52 : puts(" cannot make directory"); break;
 	 	case 0x53 : puts(" fail on INT 24h"); break;
 	 	case 0x54 : puts(" (DOS 3.3+) too many redirections"); break;
 	 	case 0x55 : puts(" (DOS 3.3+) duplicate redirection"); break;
 	 	case 0x56 : puts(" (DOS 3.3+) invalid password"); break;
 	 	case 0x57 : puts(" (DOS 3.3+) invalid parameter"); break;
 	 	case 0x58 : puts(" (DOS 3.3+) network write fault"); break;
 	 	case 0x59 : puts(" (DOS 4.0+) function not supported on network"); break;
 	 	case 0x5A : puts(" (DOS 4.0+) required system component not installed"); break;
 	 	case 0x5B : puts(" (NetWare4) timer server table overflowed"); break;
 	 	case 0x5C : puts(" (NetWare4) duplicate in timer service table"); break;
 	 	case 0x5D : puts(" (NetWare4) no items to work on"); break;
 	 	case 0x5F : puts(" (NetWare4) invalid interrupt"); break;
 	 	case 0x64 : puts(" (MSCDEX) unknown error");
 	 	            puts(" (NetWare4) open semaphore limit exceeded"); break;
 	 	case 0x65 : puts(" (MSCDEX) not ready");
 	 		    puts(" (NetWare4) exclusive semaphore is already owned"); break;
 	 	case 0x66 : puts(" (MSCDEX) EMS memory no longer valid"); 
 	 	            puts(" (NetWare4) semaphore was set when close attempted"); break;
 	 	case 0x67 : puts(" (MSCDEX) not High Sierra or ISO-9660 format");
 	 		    puts(" (NetWare4) too many exclusive semaphore requests"); break;
 	 	case 0x68 : puts(" (MSCDEX) door open");
 	 		    puts(" (NetWare4) operation invalid from interrupt handler"); break;
 	 	case 0x69 : puts(" (NetWare4) semaphore owner died"); break;
 	 	case 0x6A : puts(" (NetWare4) semaphore limit exceeded"); break;
 	 	case 0x6B : puts(" (NetWare4) insert drive B: disk into drive A:"); break;
 	 	case 0x6C : puts(" (NetWare4) drive locked by another process"); break;
 	 	case 0x6D : puts(" (NetWare4) broken pipe"); break;
 	 	case 0x6E : puts(" (NetWare4) pipe open/create failed"); break;
 	 	case 0x6F : puts(" (NetWare4) pipe buffer overflowed"); break;
 	 	case 0x70 : puts(" (NetWare4) disk full"); break;
 	 	case 0x71 : puts(" (NetWare4) no more search handles"); break;
 	 	case 0x72 : puts(" (NetWare4) invalid target handle for dup2"); break;
 	 	case 0x73 : puts(" (NetWare4) bad user virtual address"); break;
 	 	case 0x74 : puts(" (NetWare4) error on console I/O"); break;
 	 	case 0x75 : puts(" (NetWare4) unknown category code for IOCTL"); break;
 	 	case 0x76 : puts(" (NetWare4) invalid value for verify flag"); break;
 	 	case 0x77 : puts(" (NetWare4) level four driver not found"); break;
 	 	case 0x78 : puts(" (NetWare4) invalid function number"); break;
 	 	case 0x79 : puts(" (NetWare4) semaphore timeout"); break;
 	 	case 0x7A : puts(" (NetWare4) buffer too small"); break;
 	 	case 0x7B : puts(" (NetWare4) invalid character or bad file-system name"); break;
 	 	case 0x7C : puts(" (NetWare4) unimplemented information level"); break;
 	 	case 0x7D : puts(" (NetWare4) no volume label found"); break;
 	 	case 0x7E : puts(" (NetWare4) module handle not found"); break;
 	 	case 0x7F : puts(" (NetWare4) procedure address not found"); break;
 	 	case 0x80 : puts(" (NetWare4) CWait found no children"); break;
 	 	case 0x81 : puts(" (NetWare4) CWait children still running"); break;
 	 	case 0x82 : puts(" (NetWare4) invalid operation for direct disk-access handle"); break;
 	 	case 0x83 : puts(" (NetWare4) attempted seek to negative offset"); break;
 	 	case 0x84 : puts(" (NetWare4) attempted to seek on device or pipe"); break;
 	 	case 0x85 : puts(" (NetWare4) drive already has JOINed drives"); break;
 	 	case 0x86 : puts(" (NetWare4) drive is already JOINed"); break;
 	 	case 0x87 : puts(" (NetWare4) drive is already SUBSTed"); break;
 	 	case 0x88 : puts(" (NetWare4) can not delete drive which is not JOINed"); break;
 	 	case 0x89 : puts(" (NetWare4) can not delete drive which is not SUBSTed"); break;
 	 	case 0x8A : puts(" (NetWare4) can not JOIN to a JOINed drive"); break;
 	 	case 0x8B : puts(" (NetWare4) can not SUBST to a SUBSTed drive"); break;
 	 	case 0x8C : puts(" (NetWare4) can not JOIN to a SUBSTed drive"); break;
 	 	case 0x8D : puts(" (NetWare4) can not SUBST to a JOINed drive"); break;
 	 	case 0x8E : puts(" (NetWare4) drive is busy"); break;
 	 	case 0x8F : puts(" (NetWare4) can not JOIN/SUBST to same drive"); break;
 	 	case 0x90 : puts(" (NetWare4) directory must not be root directory"); break;
 	 	case 0x91 : puts(" (NetWare4) can only JOIN to empty directory"); break;
 	 	case 0x92 : puts(" (NetWare4) path is already in use for SUBST"); break;
 	 	case 0x93 : puts(" (NetWare4) path is already in use for JOIN"); break;
 	 	case 0x94 : puts(" (NetWare4) path is in use by another process"); break;
 	 	case 0x95 : puts(" (NetWare4) directory previously SUBSTituted"); break;
 	 	case 0x96 : puts(" (NetWare4) system trace error"); break;
 	 	case 0x97 : puts(" (NetWare4) invalid event count for DosMuxSemWait"); break;
 	 	case 0x98 : puts(" (NetWare4) too many waiting on mutex"); break;
 	 	case 0x99 : puts(" (NetWare4) invalid list format"); break;
 	 	case 0x9A : puts(" (NetWare4) volume label too large"); break;
 	 	case 0x9B : puts(" (NetWare4) unable to create another TCB"); break;
 	 	case 0x9C : puts(" (NetWare4) signal refused"); break;
 	 	case 0x9D : puts(" (NetWare4) segment discarded"); break;
 	 	case 0x9E : puts(" (NetWare4) segment not locked"); break;
 	 	case 0x9F : puts(" (NetWare4) invalid thread-ID address"); break;
 	 	case 0xA0 : puts(" (NetWare4) bad environment pointerv"); break;
 	 	case 0xA1 : puts(" (NetWare4) invalid name passed to EXEC"); break;
 	 	case 0xA2 : puts(" (NetWare4) signal already pending"); break;
 	 	case 0xA3 : puts(" (NetWare4) ERROR_124 mapping"); break;
 	 	case 0xA4 : puts(" (NetWare4) no more process slots"); break;
 	 	case 0xA5 : puts(" (NetWare4) ERROR_124 mapping"); break;
 	 	case 0xB0 : puts(" (MS-DOS 7.0) volume is not locked"); break;
 	 	case 0xB1 : puts(" (MS-DOS 7.0) volume is locked in drive"); break;
 	 	case 0xB2 : puts(" (MS-DOS 7.0) volume is not removable"); break;
 	 	case 0xB4 : puts(" (MS-DOS 7.0) lock count has been exceeded");
 	 		    puts(" (NetWare4) invalid segment number"); break;
 	 	case 0xB5 : puts(" (MS-DOS 7.0) a valid eject request failed");
 	 		    puts(" (NetWare4) invalid call gate"); break;
 	 	case 0xB6 : puts(" (NetWare4) invalid ordinal"); break;
 	 	case 0xB7 : puts(" (NetWare4) shared segment already exists"); break;
 	 	case 0xB8 : puts(" (NetWare4) no child process to wait for"); break;
 	 	case 0xB9 : puts(" (NetWare4) NoWait specified and child still running"); break;
 	 	case 0xBA : puts(" (NetWare4) invalid flag number"); break;
 	 	case 0xBB : puts(" (NetWare4) semaphore does not exist"); break;
 	 	case 0xBC : puts(" (NetWare4) invalid starting code segment"); break;
 	 	case 0xBD : puts(" (NetWare4) invalid stack segment"); break;
 	 	case 0xBE : puts(" (NetWare4) invalid module type (DLL can not be used as application)"); break;
 	 	case 0xBF : puts(" (NetWare4) invalid EXE signature"); break;
 	 	case 0xC0 : puts(" (NetWare4) EXE marked invalid"); break;
 	 	case 0xC1 : puts(" (NetWare4) bad EXE format (e.g. DOS-mode program)"); break;
 	 	case 0xC2 : puts(" (NetWare4) iterated data exceeds 64K"); break;
 	 	case 0xC3 : puts(" (NetWare4) invalid minimum allocation size"); break;
 	 	case 0xC4 : puts(" (NetWare4) dynamic link from invalid Ring"); break;
 	 	case 0xC5 : puts(" (NetWare4) IOPL not enabled"); break;
 	 	case 0xC6 : puts(" (NetWare4) invalid segment descriptor privilege level"); break;
 	 	case 0xC7 : puts(" (NetWare4) automatic data segment exceeds 64K"); break;
 	 	case 0xC8 : puts(" (NetWare4) Ring2 segment must be moveable"); break;
 	 	case 0xC9 : puts(" (NetWare4) relocation chain exceeds segment limit"); break;
 	 	case 0xCA : puts(" (NetWare4) infinite loop in relocation chain"); break;
 	 	case 0xCB : puts(" (NetWare4) environment variable not found"); break;
 	 	case 0xCC : puts(" (NetWare4) not current country"); break;
 	 	case 0xCD : puts(" (NetWare4) no signal sent"); break;
 	 	case 0xCE : puts(" (NetWare4) file name not 8.3"); break;
 	 	case 0xCF : puts(" (NetWare4) Ring2 stack in use"); break;
 	 	case 0xD0 : puts(" (NetWare4) meta expansion is too long"); break;
 	 	case 0xD1 : puts(" (NetWare4) invalid signal number"); break;
 	 	case 0xD2 : puts(" (NetWare4) inactive thread"); break;
 	 	case 0xD3 : puts(" (NetWare4) file system information not available"); break;
 	 	case 0xD4 : puts(" (NetWare4) locked error"); break;
 	 	case 0xD5 : puts(" (NetWare4) attempted to execute non-family API call in DOS mode"); break;
 	 	case 0xD6 : puts(" (NetWare4) too many modules"); break;
 	 	case 0xD7 : puts(" (NetWare4) nesting not allowed"); break;
 	 	case 0xE6 : puts(" (NetWare4) non-existent pipe, or bad operation"); break;
 	 	case 0xE7 : puts(" (NetWare4) pipe is busy"); break;
 	 	case 0xE8 : puts(" (NetWare4) no data available for nonblocking read"); break;
 	 	case 0xE9 : puts(" (NetWare4) pipe disconnected by server"); break;
 	 	case 0xEA : puts(" (NetWare4) more data available"); break;
 	 	case 0xFF : puts(" (NetWare4) invalid drive"); break;
		default  : printf("unknown error code: %x\n", code); break;
	 }
}
