#include "lfn.h"
#include <stdio.h>
#include <string.h>

#define ACCESS_MODE 		\
		OPEN_ACCESS_READWRITE|	\
		OPEN_SHARE_COMPATIBLE

void	printf_fileinfo(struct fileinfo finfo);
void	printf_dt(const char *s, struct datetime dt);

int main(int argc, char **argv)
{
	HFILE handle;	
	WORD action;
	WORD written;
	char filename[260];
	struct fileinfo finfo;
	struct datetime dt;

       	action = LONG_CREATE_FILE_CREATE_OPEN;

	if (argc < 2)
		return 1;

	handle = create_file(argv[1], ACCESS_MODE, FILE_ATTR_NORMAL, &action, 0);
	if (__lfnerrno != 0) 
		return 1;

	memset(&finfo, 0, sizeof finfo);

	get_file_information(handle, &finfo);
	if (__lfnerrno == 0)
		printf_fileinfo(finfo);
	memset(&dt, 0, sizeof dt);
	get_last_write_date( handle, &dt);
	if (__lfnerrno == 0) 
		printf_dt("last write date",dt);
	memset(&dt, 0, sizeof dt);
	get_creation_date( handle, &dt);
	if (__lfnerrno == 0) 
		printf_dt("creation date",dt);
	memset(&dt, 0, sizeof dt);
	get_last_access_date( handle, &dt);
	if (__lfnerrno == 0) 
		printf_dt("last access date",dt);

 	close_file(handle);

	return 0;
}

void	printf_fileinfo(struct fileinfo finfo)
{
#if 0		
	printf("file attributes                       %lu\n",finfo.fattr);
	if (finfo.fattr & FILE_ATTR_NORMAL		) puts("NORMAL	");	
	if (finfo.fattr & FILE_ATTR_READONLY       	) puts("READONLY       ");       
	if (finfo.fattr & FILE_ATTR_HIDDEN              ) puts("HIDDEN         ");  
	if (finfo.fattr & FILE_ATTR_SYSTEM              ) puts("SYSTEM         ");  
	if (finfo.fattr & FILE_ATTR_VOLUME_LABEL        ) puts("VOLUME_LABEL   ");  
	if (finfo.fattr & FILE_ATTR_DIRECTORY           ) puts("DIRECTORY      ");  
	if (finfo.fattr & FILE_ATTR_ARCHIVE             ) puts("ARCHIVE        ");  
	if (finfo.fattr & FILE_ATTR_PENDING_DELETED     ) puts("PENDING_DELETED");  
#endif
	printf("creation time (0 = unsupported)       %lu\n",finfo.creation_time);
	printf("last access time (0 = unsupported)    %lu\n",finfo.access_time);
	printf("last write time                       %lu\n",finfo.write_time);
#if 0		
	printf("volume serial number                  %lu\n",finfo.volumeID);
	printf("high 32 bits of file size             %lu\n",finfo.hi_filesize);
	printf("low 32 bits of file size              %lu\n",finfo.lo_filesize);
	printf("number of links to file               %lu\n",finfo.links);
	printf("unique file identifier (high 32 bits) %lu\n",finfo.hi_fileID);
	printf("unique file identifier (low 32 bits)  %lu\n",finfo.lo_fileID);
#endif
}

void	printf_dt(const char *s,struct datetime dt)
{
#if 0
	printf("value:  %u\n", *(DWORD *)&dt );
	printf("seconds %u\n",	DT_GET_TIME_SECONDS(dt));
	printf("minutes %u\n",	DT_GET_TIME_MINUTES(dt));
	printf("hours   %u\n",	DT_GET_TIME_HOURS(dt));
	printf("day     %u\n",	DT_GET_DATE_DAY(dt));
	printf("month   %u\n",	DT_GET_DATE_MONTH(dt));
	printf("year    %u\n",	DT_GET_DATE_YEAR(dt));
	printf("milsecs %u\n", DT_GET_MILISECS(dt));    
#endif
	printf("%020s: %02d/%02d/%d %02d:%02d\n",
		s,
                DT_GET_DATE_MONTH(dt), 
		DT_GET_DATE_DAY(dt), 
		DT_GET_DATE_YEAR(dt), 
		DT_GET_TIME_HOURS(dt), 
		DT_GET_TIME_MINUTES(dt));
}

