#include <stdio.h>
#include "lfn.h"
#include <string.h>

int main(void)
{
	struct finddata fd;
	int m0;
	HFIND handle;
	BYTE unicode;
	char attrs[8];
	char adate[32], cdate[32], wdate[32];
	WORD datetype_t[] = 
		{LONG_FIND_DATE_FILE
		,LONG_FIND_DATE_DOS	
		};
	__lfnwarnings = 2;
	printf("__lfnwarnings = %u\n", __lfnwarnings);
	printf("Directory listing of *\n");
	for (m0 = 0; m0 < 2; m0++)
	{
		BYTE datetype = datetype_t[m0];
		puts("Looking...");
		handle = find_first_file(
			FILE_ATTR_ALL, 
			FILE_ATTR_NORMAL,
			datetype, 
			NULL,
			&fd, 
			&unicode); 	
                if (__lfnerrno)
			continue;

		while (!__lfnerrno) {
			adate[0] = cdate[0] = wdate[0] = attrs[0]='\0';		
			switch(datetype)                  
			{
				case LONG_FIND_DATE_FILE:
                        	{
					struct datetime dt;
					memset(&dt, 0, sizeof dt);

					convert_time(
						&dt, 
						&fd.creation_datetime, 
						LONG_CONVERT_TIME_TO_DOS);

					sprintf(cdate,"%02u/%02u/%4u %02u:%02u:%02u"   
						,DT_GET_DATE_MONTH(dt)
						,DT_GET_DATE_DAY(dt)
						,DT_GET_DATE_YEAR(dt)
						,DT_GET_TIME_HOURS(dt)
						,DT_GET_TIME_MINUTES(dt)
						,DT_GET_TIME_SECONDS(dt)
					);

					convert_time(
						&dt, 
						&fd.write_datetime, 
						LONG_CONVERT_TIME_TO_DOS);

					sprintf(wdate,"%02u/%02u/%4u %02u:%02u:%02u"   
						,DT_GET_DATE_MONTH(dt)
						,DT_GET_DATE_DAY(dt)
						,DT_GET_DATE_YEAR(dt)
						,DT_GET_TIME_HOURS(dt)
						,DT_GET_TIME_MINUTES(dt)
						,DT_GET_TIME_SECONDS(dt)
					);

					convert_time(
						&dt, 
						&fd.access_datetime, 
						LONG_CONVERT_TIME_TO_DOS);

					sprintf(adate,"%02u/%02u/%4u %02u:%02u:%02u"   
						,DT_GET_DATE_MONTH(dt)
						,DT_GET_DATE_DAY(dt)
						,DT_GET_DATE_YEAR(dt)
						,DT_GET_TIME_HOURS(dt)
						,DT_GET_TIME_MINUTES(dt)
						,DT_GET_TIME_SECONDS(dt)
					);

					break;				
				}
				case LONG_FIND_DATE_DOS:
				{
					DWORD t_date;
					DWORD t_time; 

					t_date= GET_FD_DOS_DATE(fd.creation_datetime);
					t_time= GET_FD_DOS_TIME(fd.creation_datetime) ;  
					sprintf(cdate,"%02u/%02u/%4u %02u:%02u:%02u"
						,GET_DATE_MONTH(t_date)
						,GET_DATE_DAY(t_date)
						,GET_DATE_YEAR(t_date)
						,GET_TIME_HOURS(t_time)
						,GET_TIME_MINUTES(t_time)
						,GET_TIME_SECONDS(t_time)
					);

					t_date= GET_FD_DOS_DATE(fd.write_datetime);
					t_time= GET_FD_DOS_TIME(fd.write_datetime) ;  
					sprintf(wdate,"%02u/%02u/%4u %02u:%02u:%02u"
						,GET_DATE_MONTH(t_date)
						,GET_DATE_DAY(t_date)
						,GET_DATE_YEAR(t_date)
						,GET_TIME_HOURS(t_time)
						,GET_TIME_MINUTES(t_time)
						,GET_TIME_SECONDS(t_time)
					);

					t_date= GET_FD_DOS_DATE(fd.access_datetime);
					t_time= GET_FD_DOS_TIME(fd.access_datetime) ;  
					sprintf(adate,"%02u/%02u/%4u %02u:%02u:%02u"
						,GET_DATE_MONTH(t_date)
						,GET_DATE_DAY(t_date)
						,GET_DATE_YEAR(t_date)
						,GET_TIME_HOURS(t_time)
						,GET_TIME_MINUTES(t_time)
						,GET_TIME_SECONDS(t_time)
					);

					break;
				}
				default:
					break;
			}
			if (fd.attributes & FILE_ATTR_READONLY      ) strcat(attrs,"R"); else strcat(attrs," ");
			if (fd.attributes & FILE_ATTR_HIDDEN        ) strcat(attrs,"H"); else strcat(attrs," ");
			if (fd.attributes & FILE_ATTR_SYSTEM        ) strcat(attrs,"S"); else strcat(attrs," ");
			if (fd.attributes & FILE_ATTR_VOLUME_LABEL  ) strcat(attrs,"V"); else strcat(attrs," ");
			if (fd.attributes & FILE_ATTR_DIRECTORY     ) strcat(attrs,"D"); else strcat(attrs," ");
			if (fd.attributes & FILE_ATTR_ARCHIVE       ) strcat(attrs,"A"); else strcat(attrs," ");
			strcat(attrs," ");
			if (unicode & LONG_FIND_UNICODE_LONG	) strcat(attrs,"L"); else strcat(attrs," ");	
			if (unicode & LONG_FIND_UNICODE_SHORT   ) strcat(attrs,"S"); else strcat(attrs," ");
 
			printf("%s %s %s\n%9lu%9lu %8s %12s %s\n", cdate, adate, wdate, fd.hi_size, fd.lo_size, attrs, fd.shortname, fd.fullname);
			find_next_file(
				handle,
				datetype_t[m0], 
				&fd, 
				&unicode); 	
		}
		find_close(handle);
	}
	return 0;
}
