#include <stdio.h>
#include <string.h>
#include <dos.h>

#define MAX_PATH_LEN	260
#define	TO_8dot3	1
#define	TO_LFN		2

int 	com_LFN_check_for_longfilenames(void);
void 	com_test_LFNs(void);

int convertit_8dot3_lfn(char *buf_8dot3, char *buf_LFN);
int convertit_lfn_8dot3(char *buf_LFN, char *buf_8dot3); 

int com_LFN_8dot3_to_LFN_WIn(char *buf_8dot3, char *buf_LFN);
int com_LFN_8dot3_to_LFN_asm(char *buf_8dot3, char *buf_LFN);
int com_LFN_LFN_to_8dot3_asm(char *buf_LFN, char *buf_8dot3);

int 	com_LFN_check_for_longfilenames(void)
{
	union REGS inr;
	union REGS outr;
	struct SREGS sregs;

	memset(&sregs, 0, sizeof(struct SREGS));
	memset(&inr, 0, sizeof(union REGS));
	memset(&outr, 0, sizeof(union REGS));
	inr.x.ax=0x71A0;
	int86(0x21, &inr, &outr);
	return (outr.h.al != 0);
}

int convertit_8dot3_lfn(char *buf_8dot3, char *buf_LFN)
{
	int ok_p = 0;
	if (com_LFN_check_for_longfilenames())
		ok_p = com_LFN_8dot3_to_LFN_asm(buf_8dot3, buf_LFN);
	if (!ok_p)
		strcpy(buf_LFN, buf_8dot3);
	return ok_p;
}

int convertit_lfn_8dot3(char *buf_LFN, char *buf_8dot3)
{
	int ok_p = 0;
	if (com_LFN_check_for_longfilenames())
		ok_p = com_LFN_LFN_to_8dot3_asm(buf_LFN, buf_8dot3);
	if (!ok_p)
		strcpy(buf_8dot3, buf_LFN);
	return ok_p;
}

static int DoDosCall(unsigned func, union REGS *r, struct SREGS *s)
{
	r->x.ax = func;
	int86x(0x21, r,r,s);
	_doserrno = (r->x.cflag ? r->x.ax:0);
	return r->x.cflag;
}


int com_LFN_8dot3_to_LFN_asm(char *buf_8dot3, char *buf_LFN)
{
	union REGS r;
	struct SREGS s;

	memset(&s, 0, sizeof(struct SREGS));
	s.es = (unsigned)((unsigned long)buf_LFN >> 16);
	r.x.di = (unsigned)buf_LFN;
	s.ds = (unsigned)((unsigned long)buf_8dot3 >> 16);
	r.x.si = (unsigned)buf_8dot3;
	r.x.cx = 2;
	if (DoDosCall(0x7160, &r, &s)) {
		printf("|doserrno: %d |", _doserrno);
		return 0;
	}
	return strlen(buf_LFN);
}

int com_LFN_LFN_to_8dot3_asm(char *buf_LFN, char *buf_8dot3)
{
	union REGS r;
	struct SREGS s;

	memset(&s, 0, sizeof(struct SREGS));
	s.ds = (unsigned)((unsigned long)buf_LFN >> 16);
	r.x.si = (unsigned)buf_LFN;
	s.es = (unsigned)((unsigned long)buf_8dot3 >> 16);
	r.x.di = (unsigned)buf_8dot3;
	r.x.cx = 1;
	if (DoDosCall(0x7160, &r, &s)) {
		printf("|doserrno: %d |", _doserrno);
		return 0;
	}
	return strlen(buf_8dot3);
}

void test(int sens, char *src)
{
	char dest[MAX_PATH_LEN];
	int res;
	if (sens == TO_LFN) {
		res = convertit_8dot3_lfn(src, dest);
		printf("8dot3_to_LFN: %s -> %s, ret=%d.\n",src,dest,res);
		return;
	}	
	if (sens == TO_8dot3) {
		res = convertit_lfn_8dot3(src, dest);
		printf("LFN_to_8dot3: %s -> %s, ret=%d.\n",src,dest,res);
		return;
	}
	puts(" -- nothing --");
}

int main()
{
	if(!com_LFN_check_for_longfilenames())
		puts("long file names not supported");
	else {

		test(TO_8dot3,	"\\tmp");
		test(TO_8dot3,	"\\tmp\\");
		test(TO_LFN,	"\\tmp");
		test(TO_LFN,	"c:\\progra~1");
		test(TO_8dot3,"programme test.c");
		test(TO_8dot3,"programme test2.c");
		test(TO_8dot3,"programme test3.c");
		test(TO_LFN,"progra~1.c");
		test(TO_LFN,"progra~2.c");
		test(TO_LFN,"progra~3.c");

		test(TO_8dot3,"long name");
		test(TO_8dot3,"long name\\programme file.c");
		test(TO_LFN,"longna~1");
		test(TO_LFN,"longna~1\\progra~1.c");

	}
	return 0;
}
